-- The engine won't expose VirtualController until it's needed, so...
Input:destroy_virtual_controller(Input:create_virtual_controller("TEMPORARY"))

local norm_types = {
    [Idstring("move")] = true,
    [Idstring("drive")] = true
}

local mvec3_len = mvector3.length
local mvec3_norm = mvector3.normalize

local axis_orig = VirtualController.axis
function VirtualController:axis(type, ...)
    local axis = axis_orig(self, type, ...)

    if axis then
        if norm_types[type] and mvec3_len(axis) > 1 then
            mvec3_norm(axis)
        end

        return axis
    end
end
